/* sf25r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

real sf25r_c(real *x)
{
    /* Initialized data */

    static real sys010 = .7978845f;
    static real sd2pi = 2.356194f;
    static real a[18] = { -4e-20f,2.95e-18f,-1.9554e-16f,1.138572e-14f,
            -5.777404e-13f,2.528123e-11f,-9.424212e-10f,2.949707e-8f,
            -7.617587e-7f,1.588701e-5f,-2.604443e-4f,.00324027f,-.02917552f,
            .1777091f,-.6614439f,1.287994f,-1.191801f,1.296717f };
    static real c__[18] = { 0.f,0.f,1.2e-19f,-5.8e-19f,3.05e-18f,-1.731e-17f,
            1.0668e-16f,-7.2212e-16f,5.45267e-15f,-4.684224e-14f,
            4.699195e-13f,-5.704863e-12f,8.816898e-11f,-1.87189e-9f,
            6.177633e-8f,-3.987284e-6f,8.989898e-4f,2.001806f };
    static real d__[18] = { 0.f,3e-20f,-1.4e-19f,6.5e-19f,-3.28e-18f,
            1.768e-17f,-1.0269e-16f,6.5083e-16f,-4.56125e-15f,3.596777e-14f,
            -3.264315e-13f,3.515218e-12f,-4.686363e-11f,8.229193e-10f,
            -2.095978e-8f,9.138615e-7f,-9.627723e-5f,.09355557f };

    /* System generated locals */
    real ret_val;

    /* Builtin functions */
    double cos(doublereal), sin(doublereal), sqrt(doublereal);

    /* Local variables */
    static integer i__;
    static real y, z__, q1, q2, q3, x1, x2, x3, x4, fx;

    y = abs(*x);
    z__ = y * .125f;
    if (z__ > 1.f) {
        goto L3;
    }
    if (z__ <= 0.f) {
        goto L2;
    }
    x2 = z__ * 4.f * z__ - 2.f;
    q3 = 0.f;
    q2 = 0.f;
    for (i__ = 1; i__ <= 18; ++i__) {
        q1 = q2;
        q2 = q3;
        q3 = x2 * q2 - q1 + a[i__ - 1];
/* L1: */
    }
    ret_val = (q3 - q1) * .5f * z__;
    goto L6;
L2:
    ret_val = 0.f;
    goto L6;
L3:
    z__ = 1.f / z__;
    x2 = z__ * 4.f * z__ - 2.f;
    q3 = 0.f;
    q2 = 0.f;
    for (i__ = 1; i__ <= 18; ++i__) {
        q1 = q2;
        q2 = q3;
        q3 = x2 * q2 - q1 + c__[i__ - 1];
/* L4: */
    }
    x1 = (q3 - q1) * .5f;
    q3 = 0.f;
    q2 = 0.f;
    for (i__ = 1; i__ <= 18; ++i__) {
        q1 = q2;
        q2 = q3;
        q3 = x2 * q2 - q1 + d__[i__ - 1];
/* L5: */
    }
    fx = (q3 - q1) * .5f;
    x2 = (real)cos((real)(y - sd2pi));
    x3 = (real)sin((real)(y - sd2pi));
    x4 = sys010 / (real)sqrt(y);
    fx *= z__;
    ret_val = x4 * (x1 * x2 - fx * x3);
L6:
    return ret_val;
} /* sf25r_c */
